package com.llw.libjava.commons.pojo;

public class ObjectWrapper<T> {
	private T object = null;
	private boolean isValid = false;
	
	private ObjectWrapper() {
	}
	
	private ObjectWrapper(T object, boolean isValid) {
		this.object = object;
		this.isValid = isValid;
	}
	
	public static <T> ObjectWrapper<T> newInvalidObject() {
		return new ObjectWrapper<T>();
	}
	
	public static <T> ObjectWrapper<T> newValidObject(T object) {
		return new ObjectWrapper<T>(object, true);
	}

	public T getObject() {
		return object;
	}

	public boolean isValid() {
		return isValid;
	}
}
