package com.llw.libjava.commons.util;

import com.llw.libjava.commons.constant.SymbolConstants;

public class ApplicationEntrenceUtil {
	
	private ApplicationEntrenceUtil() {
	}
	
	public static class UsageUtil {
		private String[] defaultUsageSegments = null;
	
		public UsageUtil(String defaultUsageSegment) {
			setDefaultUsageSegments(new String[]{defaultUsageSegment});
		}
	
		public UsageUtil(String[] defaultUsageSegments) {
			setDefaultUsageSegments(defaultUsageSegments);
		}
		
		private void setDefaultUsageSegments(String[] defaultUsageSegments) {
			this.defaultUsageSegments = defaultUsageSegments;
		}
		
		private void printUsage(StringBuilder usageBuilder) {
			for (int i = 0; i < defaultUsageSegments.length; i++) {
				usageBuilder.append(defaultUsageSegments[i]);
			}
			String usage = usageBuilder.toString();
			System.out.println(usage);
		}
	
		public void printUsage() {
			printUsage(new StringBuilder());
		}
		
		private void printUsage(StringBuilder usageBuilder, String errorMessageDelimiter, String... errorMessages) {
			if (errorMessages != null && !"".equals(errorMessages)) {
				if (errorMessageDelimiter == null) {
					errorMessageDelimiter = "";
				}
				int i = 0;
				for (; i < errorMessages.length; i++) {
					String errorMessage = errorMessages[i];
					if (errorMessage == null || "".equals(errorMessage)) {
						continue;
					}
					usageBuilder.append(errorMessage);
					usageBuilder.append(errorMessageDelimiter);
				}
				if (i > 0) {
					usageBuilder.append(SymbolConstants.NEW_LINE);
				}
			}
			printUsage(usageBuilder);
		}
		
		public void printUsage(String errorMessage) {
			printUsage(new StringBuilder(), null, errorMessage);
		}
		
		public void printUsageLineByLine(String... errorMessages) {
			printUsage(new StringBuilder(), SymbolConstants.NEW_LINE, errorMessages);
		}
		
		public void printUsageAppending(String... errorMessages) {
			printUsage(new StringBuilder(), null, errorMessages);
		}
	}
}
