package com.llw.libjava.commons.util;

/**
 * 
 * @author zhubolin
 * @description instead by ByteUtil
 */
@Deprecated
public class ByteProcessingUtil {

	private ByteProcessingUtil() {
	}

	public static String transformByteArray2HexString(byte[] byteArray) {
		if (byteArray == null || byteArray.length == 0) {
			// ExceptionUtil.throwNullArgumentException();
			return null;
		}
		int hexStringLength = byteArray.length << 1;
		StringBuilder hexStringBuilder = new StringBuilder(hexStringLength);
		for (byte oneByte : byteArray) {
			int integer = (int) oneByte;
			if (integer < 0) {
				integer += 256;
			}
			String byteChar = Integer.toHexString(integer).toUpperCase();
			if (byteChar.length() == 1) {
				byteChar = "0" + byteChar;
			}
			hexStringBuilder.append(byteChar);
		}
		String hexString = hexStringBuilder.toString();
		return hexString;
	}

	public static byte[] transformHexString2ByteArray(String hexString) {
		if (hexString == null || hexString.equals("")) {
			// ExceptionUtil.throwNullArgumentException();
			return null;
		}
		int hexStringLength = hexString.length();
		if (hexStringLength % 2 != 0) {
			throw new IllegalArgumentException("The length of hexadecimal string must be an even number!");
		}
		int byteArrayLength = hexStringLength >> 1;
		byte[] byteArray = new byte[byteArrayLength];
		char[] hexCharArray = hexString.toCharArray();
		for (int i = 0; i < hexStringLength; i += 2) {
			int integer = Integer.parseInt(String.valueOf(hexCharArray, i, 2), 16);
			byteArray[i >> 1] = (byte) integer;
		}
		return byteArray;
	}
	
	public static byte[] ipValueOf(int[] ipArray) {
		AssertUtil.assertEquivalentNumericalValue(4, ipArray.length);
		byte[] ipBytes = new byte[4];
		for (int i = 0; i < 4; i++) {
			ipBytes[i] = (byte) ipArray[i];
		}
		return ipBytes;
	}
}
