package com.llw.libjava.commons.util;

public class ConcurrentCounter {
	
	private ConcurrentCounter() {
	}
	
	public static ConcurrentIntCounter createIntCounter(int initialCount) {
		return new ConcurrentIntCounter(initialCount);
	}
	
	public static ConcurrentLongCounter createLongCounter(long initialCount) {
		return new ConcurrentLongCounter(initialCount);
	}
	
	public static class ConcurrentIntCounter {
		private int count = 0;
		
		private ConcurrentIntCounter(int initialCount) {
			syncCount(initialCount);
		}

		public synchronized int syncCount(int offset) {
			count += offset;
			if (count < 0) {
				count = 0;
			}
			return count;
		}
	}
	
	public static class ConcurrentLongCounter {
		private long count = 0;
		
		private ConcurrentLongCounter(long initialCount) {
			syncCount(initialCount);
		}

		public synchronized long syncCount(long offset) {
			count += offset;
			if (count < 0) {
				count = 0;
			}
			return count;
		}
	}
}
