package com.llw.libjava.commons.util;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.google.gson.Gson;

@SuppressWarnings("unchecked")
public class GsonUtil {
	private static final Gson GSON_INSTANCE = new Gson();

	private GsonUtil() {
	}

	public static Map<String, Object> toMap(String jsonString) {
		return GSON_INSTANCE.fromJson(jsonString, Map.class);
	}

	public static List<Object> toList(String jsonString) {
		return GSON_INSTANCE.fromJson(jsonString, List.class);
	}

	public static <K, V> String fromGenericMap(Map<K, V> jsonMap) {
		return GSON_INSTANCE.toJson(jsonMap, Map.class);
	}

	public static String fromMap(Map<String, Object> jsonMap) {
		return GSON_INSTANCE.toJson(jsonMap, Map.class);
	}

	public static <E> String fromGenericList(List<E> jsonList) {
		// return GSON_INSTANCE.toJson(jsonList, List.class);
		return fromGenericCollection(jsonList);
	}

	public static String fromList(List<Object> jsonList) {
		// return GSON_INSTANCE.toJson(jsonList, List.class);
		return fromCollection(jsonList);
	}

	public static <E> String fromGenericSet(Set<E> jsonSet) {
		// return GSON_INSTANCE.toJson(jsonSet, Set.class);
		return fromGenericCollection(jsonSet);
	}

	public static String fromSet(Set<Object> jsonSet) {
		// return GSON_INSTANCE.toJson(jsonSet, Set.class);
		return fromCollection(jsonSet);
	}

	public static <E> String fromGenericCollection(Collection<E> jsonCollection) {
		return GSON_INSTANCE.toJson(jsonCollection, Collection.class);
	}

	public static String fromCollection(Collection<Object> jsonCollection) {
		return GSON_INSTANCE.toJson(jsonCollection, Collection.class);
	}
}
