package com.llw.libjava.commons.util;

import java.net.InetAddress;

public class NetUtil {

	private NetUtil() {
	}

	public static String inetAddressIP2String(InetAddress inetAddress) {
		return inetAddress.getHostAddress();
	}

	public static String byteArrayIP2String(byte[] ipByteArray) {
		if (ipByteArray.length != 4) {
			throw new IllegalArgumentException("not a ip byte array");
		}
		StringBuilder ipBuilder = new StringBuilder();
		ipBuilder.append(ByteUtil.byte2UnsignedInt(ipByteArray[0]));
		int length = ipByteArray.length;
		for (int i = 1; i < length; i++) {
			ipBuilder.append(".");
			ipBuilder.append(ByteUtil.byte2UnsignedInt(ipByteArray[i]));
		}
		String ip = ipBuilder.toString();
		return ip;
	}

	public static byte[] ipValueOf(int[] ipArray) {
		AssertUtil.assertEquivalentNumericalValue(4, ipArray.length);
		byte[] ipBytes = new byte[4];
		for (int i = 0; i < 4; i++) {
			ipBytes[i] = (byte) ipArray[i];
		}
		return ipBytes;
	}
}
