package com.llw.libjava.commons.util.index.template;

import com.llw.libjava.commons.util.index.OrderedIdxGenerator;
import com.llw.libjava.commons.util.index.UniqIdxGenerator;

public class OrderedUniqIdxGenerator<T> implements UniqIdxGenerator<T> {
	private OrderedIdxGenerator<T> orderedIdxGenerator = null;
	private T lastOrderedIdx = null;

	public OrderedUniqIdxGenerator(OrderedIdxGenerator<T> orderedIdxGenerator) {
		this.orderedIdxGenerator = orderedIdxGenerator;
	}

	public T generateUniqIdx() {
		return generateOrderedIdx();
	}

	private synchronized T generateOrderedIdx() {
		T newOrderedIdx = null;
		while ((newOrderedIdx = nextOrderedIdx()).equals(lastOrderedIdx)) {
		}
		return lastOrderedIdx = newOrderedIdx;
	}

	private T nextOrderedIdx() {
		return orderedIdxGenerator.nextOrderedIdx();
	}
}
