package com.llw.libjava.commons.util.iterate;

public class IterableProxy<E> implements Iterable<E> {
	private Iterable<E> proxy = null;
	private IteratorProxyFactory<E> factory = null;

	public IterableProxy(Iterable<E> proxy) {
		this.proxy = proxy;
	}

	public IterableProxy(Iterable<E> proxy, IteratorProxyFactory<E> factory) {
		this(proxy);
		this.factory = factory;
	}
	
	public Iterable<E> getProxy() {
		return proxy;
	}

	public IteratorProxy<E> iterator() {
		if (factory != null) {
			return factory.createInstance(proxy.iterator());
		}
		return new IteratorProxy<E>(proxy.iterator());
	}
}
