package com.llw.libjava.commons.util.iterate;

import java.util.Iterator;

public class IteratorProxy<E> implements Iterator<E> {
	private Iterator<E> proxy = null;
	
	public IteratorProxy(Iterator<E> proxy) {
		this.proxy = proxy;
	}
	
	public Iterator<E> getProxy() {
		return proxy;
	}

	public boolean hasNext() {
		return proxy.hasNext();
	}

	public E next() {
		return proxy.next();
	}

	public void remove() {
		proxy.remove();
	}
}
