package com.llw.libjava.commons.util.iterate;

import java.util.Iterator;

import com.llw.libjava.commons.pojo.ObjectWrapper;

public class IteratorReader<T> {
	private Iterator<T> iterator = null;
	
	public IteratorReader(Iterator<T> iterator) {
		this.iterator = iterator;
	}
	
	public IteratorReader(Iterable<T> iterable) {
		this.iterator = iterable.iterator();
	}
	
	public ObjectWrapper<T> readAsObjectWrapper() {
		synchronized (iterator) {
			if (!iterator.hasNext()) {
				return null;
			} else {
				T object = iterator.next();
				return ObjectWrapper.newValidObject(object);
			}
		}
	}
}
