package security.cipher4j.base;

public enum CipherTargetType {
	/**
	 * 二进制数据
	 */
	BinaryData,
	/**
	 * 二进制文件
	 */
	BinaryFile,
	/**
	 * 短文本
	 */
	ShortText,
	/**
	 * 长文本
	 */
	LongText,
	/**
	 * 文本文件
	 */
	TextFile,
	/**
	 * 图像文件
	 */
	ImageFile,
	/**
	 * 音频文件
	 */
	AudioFile,
	/**
	 * 视频文件
	 */
	VideoFile;
	
	private static final CipherTargetType[] ALL_TYPES = CipherTargetType.values();
	
	public static CipherTargetType valueAt(int index) {
		return ALL_TYPES[index];
	}
	
	public static int valueIndex(CipherTargetType cipherTargetType) {
		for (int i = 0; i < ALL_TYPES.length; i++) {
			if (ALL_TYPES[i].equals(cipherTargetType)) {
				return i;
			}
		}
		return -1;
	}
}
