package security.cipher4j.base.attr.rsa;

import security.cipher4j.base.CipherConstants;
import security.cipher4j.base.attr.CipherToolAttributeTemplate;

public class RsaCipherToolAttribute extends CipherToolAttributeTemplate {

	private RsaCipherToolAttribute(int keySizeActual, int cleartextBufferSize, int ciphertextBufferSize) {
		super(CipherConstants.ALGORITHM_NAME_RSA, CipherConstants.KEY_SIZE_RSA_MINIMUM, -1, keySizeActual, cleartextBufferSize, ciphertextBufferSize);
	}

	public static RsaCipherToolAttribute createInstance() {
		return createInstance(CipherConstants.KEY_SIZE_RSA_MINIMUM);
	}

	public static RsaCipherToolAttribute createInstance(int keySize) {
		int ciphertextBufferSize = keySize >> 3;
		int cleartextBufferSize = ciphertextBufferSize - 11;
		return new RsaCipherToolAttribute(keySize, cleartextBufferSize, ciphertextBufferSize);
	}
}
