package security.cipher4j.base.util;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

public class RsaPemUtil {

	private RsaPemUtil() {
	}

	public static String toString(BufferedReader reader) throws Exception {
		try {
			StringBuilder rsaKeyBuilder = new StringBuilder();
			String line = null;
			while ((line = reader.readLine()) != null) {
				line = line.trim();
				if (line.equals("") || line.startsWith("--")) {
					continue;
				}
				rsaKeyBuilder.append(line);
				rsaKeyBuilder.append("\n");
			}
			String rsaKey = rsaKeyBuilder.toString();
			return rsaKey;
		} finally {
			if (reader != null) {
				reader.close();
			}
		}
	}

	public static String toString(InputStreamReader inputStreamReader) throws Exception {
		try {
			String rsaKey = toString(new BufferedReader(inputStreamReader));
			return rsaKey;
		} finally {
			if (inputStreamReader != null) {
				inputStreamReader.close();
			}
		}
	}

	public static String toString(InputStream inputStream) throws Exception {
		try {
			String rsaKey = toString(new BufferedReader(new InputStreamReader(inputStream)));
			return rsaKey;
		} finally {
			if (inputStream != null) {
				inputStream.close();
			}
		}
	}
}
